
// SPDX-License-Identifier: GPL-3.0-or-later
//
// test_bdc_hashtable.c
//
// Copyright (C) 2011-2024, University of Vienna and Vienna Institute for Nature Conservation & Analyses, Andreas Gattringer.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
//

#include <stdlib.h>
#include "bdc_hashtable/bdc_hashtable.h"
#include "bdc_strings/bdc_strings.h"


int main(int argc, char **argv)
{
        //logging_initialize(LOG_DEBUG, NULL, NULL, false);
        struct bdc_hash_table *t = new_hash_table();
        bdc_ht_add_string(t, "a", "b12345");
        bdc_ht_add_string(t, "a", "c123123");
        bdc_ht_add_string(t, "b", "d21542");
        bdc_ht_add_string(t, "c", "d316315");
        bdc_ht_add_string(t, "d", "d1326536");
        bdc_ht_add_string(t, "a", "d316136");
        remove_key(t, "a");
        bdc_ht_add_string(t, "a", "e13616136136");
        destroy_hash_table(&t);

        struct string_substitution *s = new_substituter();
        add_substitution(s, "%a", "<was a>");
        add_substitution(s, "%b", "<was b>");
        add_substitution(s, "%c", "<was c>");
        const char *orig = "%c-%a-%b-%c-aa-%d";
        char *x = substitute_string(orig, s);
        printf("%s -> %s\n", orig, x);
        destroy_substituter(&s);
        free(x);
        return 0;
}